unit UDemo;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs, FMX.StdCtrls,
  FMX.Controls.Presentation, FMX.Edit, FMX.TMSFNCCustomControl,
  FMX.TMSFNCCustomScrollControl, FMX.TMSFNCGridData, FMX.TMSFNCCustomGrid,
  FMX.TMSFNCGrid, FMX.TMSFNCTypes, FMX.TMSFNCUtils, FMX.TMSFNCGraphics,
  FMX.TMSFNCGraphicsTypes, FMX.TMSFNCGridCell, FMX.TMSFNCGridOptions;

type
  TForm130 = class(TForm)
    TMSFNCGrid1: TTMSFNCGrid;
    Panel1: TPanel;
    Button1: TButton;
    Edit1: TEdit;
    Label1: TLabel;
    Edit2: TEdit;
    Label2: TLabel;
    btnShowHideFilters: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Edit1ChangeTracking(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Edit2ChangeTracking(Sender: TObject);
    procedure btnShowHideFiltersClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form130: TForm130;

implementation

{$R *.fmx}


procedure TForm130.btnShowHideFiltersClick(Sender: TObject);
begin
  TMSFNCGrid1.BeginUpdate;
  try
    TMSFNCGrid1.Options.Filtering.DropDown := not TMSFNCGrid1.Options.Filtering.DropDown;
    if TMSFNCGrid1.Options.Filtering.DropDown then
      btnShowHideFilters.Text := 'Hide filters'
    else
    begin
      btnShowHideFilters.Text := 'Show filters';
      TMSFNCGrid1.RemoveFilters;
    end;

  finally
    TMSFNCGrid1.EndUpdate;
  end;
end;

procedure TForm130.Button1Click(Sender: TObject);
var
  fltr: TTMSFNCGridFilterData;
begin
  TMSFNCGrid1.Filter.Clear;
  fltr := TMSFNCGrid1.Filter.Add;

  fltr.Column := 1;
  fltr.Condition := 'A*';

  Edit1.Text := 'A';

  TMSFNCGrid1.ApplyFilter;
end;

procedure TForm130.Edit1ChangeTracking(Sender: TObject);
var
  fltr: TTMSFNCGridFilterData;
begin
  TMSFNCGrid1.UnHideRowsAll;

  TMSFNCGrid1.Filter.Clear;
  fltr := TMSFNCGrid1.Filter.Add;

  fltr.Column := 1;
  fltr.CaseSensitive := false;
  fltr.Condition := Edit1.Text + '*';

  TMSFNCGrid1.ApplyFilter;
end;

procedure TForm130.Edit2ChangeTracking(Sender: TObject);
var
  fltr: TTMSFNCGridFilterData;
begin
  TMSFNCGrid1.UnHideRowsAll;

  TMSFNCGrid1.Filter.Clear;
  fltr := TMSFNCGrid1.Filter.Add;

  fltr.Column := 7;
  fltr.CaseSensitive := false;
  fltr.Condition := Edit2.Text + '*';

  TMSFNCGrid1.ApplyFilter;
end;

procedure TForm130.FormCreate(Sender: TObject);
begin
  TMSFNCGrid1.IOOffset := Point(1, 1);
  TMSFNCGrid1.LoadFromCSV('CARS.csv');
  TMSFNCGrid1.SortData(1, sdAscending);
  TMSFNCGrid1.Cells[1, 0] := 'Brand';
  TMSFNCGrid1.Cells[2, 0] := 'Type';
  TMSFNCGrid1.Cells[3, 0] := 'CC';
  TMSFNCGrid1.Cells[4, 0] := 'Hp';
  TMSFNCGrid1.Cells[5, 0] := 'Cyl';
  TMSFNCGrid1.Cells[6, 0] := 'Kw';
  TMSFNCGrid1.Cells[7, 0] := 'Price';
  TMSFNCGrid1.Cells[8, 0] := 'Country';
  TMSFNCGrid1.Options.Filtering.DropDown := True;

  Edit1.SetFocus;
end;

end.
